#include <iostream>
#include <vector>

using namespace std;

int N,k,a;
vector<int>A;


int fja(vector<int>A,int k){
    long long suma=0;
    if(k==0){
        for(auto it=A.begin();it!=A.end();it++)suma=(suma+(*it))%(1000000007);
        return suma;
    }else{
        int duzina=A.size();
        for(int i=0;i<duzina;i++){
            for(int j=i;j<duzina;j++){
                vector<int>b(A.begin()+i,A.begin()+j+1);
                suma=(suma+fja(b,k-1))%(1000000007);
            }
        }
        return suma;
    }

}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>N>>k;
    for(int i=0;i<N;i++){
        cin>>a;
        A.push_back(a);
    }



    cout<<fja(A,k);

}